Package org.apache.commons.math3.fitting.leastsquares

# Interface LeastSquaresProblem.Evaluation

All Known Subinterfaces:
  `LeastSquaresOptimizer.Optimum`

All Known Implementing Classes:
  `AbstractEvaluation`

Enclosing interface:
  `LeastSquaresProblem`

public static interface LeastSquaresProblem.Evaluation
An evaluation of a `LeastSquaresProblem` at a particular point. This class also computes several quantities derived from the value and its Jacobian.

## Method Summary

Modifier and Type
Method
Description
`double`
`getCost()`
Get the cost.
`RealMatrix`
`getCovariances(double threshold)`
Get the covariance matrix of the optimized parameters.
`RealMatrix`
`getJacobian()`
Get the weighted Jacobian matrix.
`RealVector`
`getPoint()`
Get the abscissa (independent variables) of this evaluation.
`RealVector`
`getResiduals()`
Get the weighted residuals.
`double`
`getRMS()`
Get the normalized cost.
`RealVector`
`getSigma(double covarianceSingularityThreshold)`
Get an estimate of the standard deviation of the parameters.

## Method Details

### getCovariances

RealMatrix getCovariances(double threshold)
Get the covariance matrix of the optimized parameters.
Note that this operation involves the inversion of the `JTJ` matrix, where `J` is the Jacobian matrix. The `threshold` parameter is a way for the caller to specify that the result of this computation should be considered meaningless, and thus trigger an exception.

Parameters:
  `threshold` - Singularity threshold.
Returns:
  the covariance matrix.
Throws:
  `SingularMatrixException` - if the covariance matrix cannot be computed (singular problem).

### getSigma

RealVector getSigma(double covarianceSingularityThreshold)
Get an estimate of the standard deviation of the parameters. The returned values are the square root of the diagonal coefficients of the covariance matrix, `sd(a[i]) ~= sqrt(C[i][i])`, where `a[i]` is the optimized value of the `i`-th parameter, and `C` is the covariance matrix.

Parameters:
  `covarianceSingularityThreshold` - Singularity threshold (see `computeCovariances`).
Returns:
  an estimate of the standard deviation of the optimized parameters
Throws:
  `SingularMatrixException` - if the covariance matrix cannot be computed.

### getRMS

double getRMS()
Get the normalized cost. It is the square-root of the sum of squared of the residuals, divided by the number of measurements.

Returns:
  the cost.

### getJacobian

RealMatrix getJacobian()
Get the weighted Jacobian matrix.

Returns:
  the weighted Jacobian: W1/2 J.
Throws:
  `DimensionMismatchException` - if the Jacobian dimension does not match problem dimension.

### getCost

double getCost()
Get the cost.

Returns:
  the cost.
See Also:
  - `getResiduals()`

### getResiduals

RealVector getResiduals()
Get the weighted residuals. The residual is the difference between the observed (target) values and the model (objective function) value. There is one residual for each element of the vector-valued function. The raw residuals are then multiplied by the square root of the weight matrix.

Returns:
  the weighted residuals: W1/2 K.
Throws:
  `DimensionMismatchException` - if the residuals have the wrong length.

### getPoint

RealVector getPoint()
Get the abscissa (independent variables) of this evaluation.

Returns:
  the point provided to `LeastSquaresProblem.evaluate(RealVector)`.